################################################################################
# Tests for SubDivStrat, which wraps fmatch and provides some useful statistics
################################################################################

context("SubDivStrat")

### Commented out because matched.distances = TRUE not implemented yet.
### test_that("Matched Distances", {
###   d <- matrix(c(1,2,3,4), nrow = 2, dimnames = list(c(1,2), c(3,4)))
###   # these values were generated by debugging the fullmatch function on:
###   #   fullmatch(d)
###   # and then saving the call to SubDivStrat
###   max.cpt <- 2
###   min.cpt <- 0.5
###   tolerance <- 0.004
###   # omit.fraction is NULL
###
###   res <- SubDivStrat(rownames = rownames(d), colnames = colnames(d),
###                      distmat = d, max.cpt = max.cpt, min.cpt = min.cpt,
###                      tolerance = tolerance, omit.fraction = NULL)
###
###   # result from .fullmatch
###   # cells
###   # 1 2 3 4
###   # 1 2 1 2
###   #
###   # $err
###   # [1] -0.008
###   #
###   # $match.distance
###   # [1] 0
###
###   # if the pairs are 1-3, 2-4, the matched distances are c(1,4)
###
###   expect_equivalent(res$match.distance, c(1,4))
###
### })

test_that("No Warnings", {
  d <- matrix(c(1,2,3,4), nrow = 2, dimnames = list(c(1,2), c(3,4)))
  # these values were generated by debugging the fullmatch function on:
  #   fullmatch(d)
  # and then saving the call to SubDivStrat
  max.cpt <- 2
  min.cpt <- 0.5
  tolerance <- 0.004
  # omit.fraction is NULL

  expect_silent(
    res <- SubDivStrat(rownames = rownames(d), colnames = colnames(d),
                       distspec = d, max.cpt = max.cpt, min.cpt = min.cpt,
                       tolerance = tolerance, omit.fraction = NULL)
  )
})

test_that("NA for unmatched items", {
  d <- matrix(c(1,2, 3,4, Inf, Inf), nrow = 2, dimnames = list(c(1,2), c(3,4, "U")))
  max.cpt <- 3
  min.cpt <- 0.5
  tolerance <- 0.005

  res <- SubDivStrat(rownames = rownames(d), colnames = colnames(d),
                     distspec = d, max.cpt = max.cpt, min.cpt = min.cpt,
                     tolerance = tolerance, omit.fraction = NULL)

  expect_equal(length(res$cells), 5)

})

test_that("NA is true, not string", {
  expect_warning(f1 <- fullmatch(pr ~ cost, min = 10, data = nuclearplants,
                                 within = exactMatch(pr ~ pt, data = nuclearplants)))
  expect_true(all(is.na(f1)))
})
